/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
/**
 * SelfSessionApi - axios parameter creator
 * @export
 */
export const SelfSessionApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Initiate the Log out workflow.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SelfSessionLogoutPost: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/self/session/logout`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SelfSessionOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/self/session`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Initiate the login workflow with the default (NFDI4Ing AAI) provider.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        login: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/self/session`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Initiate the login workflow with specific provider.
         * @param {string} externalAuthenticatorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        loginWithProvider: async (externalAuthenticatorId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'externalAuthenticatorId' is not null or undefined
            assertParamExists('loginWithProvider', 'externalAuthenticatorId', externalAuthenticatorId)
            const localVarPath = `/api/v2/self/session/{externalAuthenticatorId}`
                .replace(`{${"externalAuthenticatorId"}}`, encodeURIComponent(String(externalAuthenticatorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Initiate the merge workflow with specific provider.
         * @param {string} externalAuthenticatorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        merge: async (externalAuthenticatorId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'externalAuthenticatorId' is not null or undefined
            assertParamExists('merge', 'externalAuthenticatorId', externalAuthenticatorId)
            const localVarPath = `/api/v2/self/session/merge/{externalAuthenticatorId}`
                .replace(`{${"externalAuthenticatorId"}}`, encodeURIComponent(String(externalAuthenticatorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SelfSessionApi - functional programming interface
 * @export
 */
export const SelfSessionApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SelfSessionApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Initiate the Log out workflow.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2SelfSessionLogoutPost(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2SelfSessionLogoutPost(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfSessionApi.apiV2SelfSessionLogoutPost']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2SelfSessionOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2SelfSessionOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfSessionApi.apiV2SelfSessionOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Initiate the login workflow with the default (NFDI4Ing AAI) provider.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async login(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.login(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfSessionApi.login']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Initiate the login workflow with specific provider.
         * @param {string} externalAuthenticatorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async loginWithProvider(externalAuthenticatorId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.loginWithProvider(externalAuthenticatorId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfSessionApi.loginWithProvider']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Initiate the merge workflow with specific provider.
         * @param {string} externalAuthenticatorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async merge(externalAuthenticatorId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.merge(externalAuthenticatorId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfSessionApi.merge']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * SelfSessionApi - factory interface
 * @export
 */
export const SelfSessionApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SelfSessionApiFp(configuration)
    return {
        /**
         * 
         * @summary Initiate the Log out workflow.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SelfSessionLogoutPost(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2SelfSessionLogoutPost(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SelfSessionOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2SelfSessionOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Initiate the login workflow with the default (NFDI4Ing AAI) provider.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        login(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.login(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Initiate the login workflow with specific provider.
         * @param {SelfSessionApiLoginWithProviderRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        loginWithProvider(requestParameters: SelfSessionApiLoginWithProviderRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.loginWithProvider(requestParameters.externalAuthenticatorId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Initiate the merge workflow with specific provider.
         * @param {SelfSessionApiMergeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        merge(requestParameters: SelfSessionApiMergeRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.merge(requestParameters.externalAuthenticatorId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for loginWithProvider operation in SelfSessionApi.
 * @export
 * @interface SelfSessionApiLoginWithProviderRequest
 */
export interface SelfSessionApiLoginWithProviderRequest {
    /**
     * 
     * @type {string}
     * @memberof SelfSessionApiLoginWithProvider
     */
    readonly externalAuthenticatorId: string
}

/**
 * Request parameters for merge operation in SelfSessionApi.
 * @export
 * @interface SelfSessionApiMergeRequest
 */
export interface SelfSessionApiMergeRequest {
    /**
     * 
     * @type {string}
     * @memberof SelfSessionApiMerge
     */
    readonly externalAuthenticatorId: string
}

/**
 * SelfSessionApi - object-oriented interface
 * @export
 * @class SelfSessionApi
 * @extends {BaseAPI}
 */
export class SelfSessionApi extends BaseAPI {
    /**
     * 
     * @summary Initiate the Log out workflow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfSessionApi
     */
    public apiV2SelfSessionLogoutPost(options?: RawAxiosRequestConfig) {
        return SelfSessionApiFp(this.configuration).apiV2SelfSessionLogoutPost(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfSessionApi
     */
    public apiV2SelfSessionOptions(options?: RawAxiosRequestConfig) {
        return SelfSessionApiFp(this.configuration).apiV2SelfSessionOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Initiate the login workflow with the default (NFDI4Ing AAI) provider.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfSessionApi
     */
    public login(options?: RawAxiosRequestConfig) {
        return SelfSessionApiFp(this.configuration).login(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Initiate the login workflow with specific provider.
     * @param {SelfSessionApiLoginWithProviderRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfSessionApi
     */
    public loginWithProvider(requestParameters: SelfSessionApiLoginWithProviderRequest, options?: RawAxiosRequestConfig) {
        return SelfSessionApiFp(this.configuration).loginWithProvider(requestParameters.externalAuthenticatorId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Initiate the merge workflow with specific provider.
     * @param {SelfSessionApiMergeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfSessionApi
     */
    public merge(requestParameters: SelfSessionApiMergeRequest, options?: RawAxiosRequestConfig) {
        return SelfSessionApiFp(this.configuration).merge(requestParameters.externalAuthenticatorId, options).then((request) => request(this.axios, this.basePath));
    }
}

